﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Xml.Linq;
using GestureLib;
using Leap;
using Excel = Microsoft.Office.Interop.Excel;
using Office = Microsoft.Office.Core;
using Microsoft.Office.Tools.Excel;

namespace LEAPExcelController
{
    public partial class ThisAddIn
    {
        private Controller controller;
        private GestureListener listener;
        private DateTime LastGesture;

        //TODO: indikator for on/off evt title af window (latch til eventet når title ændrer sig)


        private void ThisAddIn_Startup(object sender, System.EventArgs e)
        {
            listener = new GestureListener(1500);
            listener.onGesture += listener_onGesture;

            //if(Properties.Settings.Default.LeapEnabled)
            //   StartLeap();

        }

        private void ThisAddIn_Shutdown(object sender, System.EventArgs e)
        {
            if (controller == null) return;
            StopLeap();
        }

        public void StartLeap()
        {

         //   Application.Caption =
        //        Application.Caption + " - LEAP Activated ";
            LastGesture = DateTime.Now.AddSeconds(-1);
            controller = new Controller(listener);
        }

        public void StopLeap()
        {
           // Application.Caption = Application.Caption.Replace(" - LEAP Activated ", "");
            controller.RemoveListener(listener);
            controller.Dispose();
        }

        void listener_onGesture(Gesture gesture)
        {
            //string gestures = "";
            foreach (Gesture.Direction direction in gesture.directions)
            {
                //     gestures += direction.ToString() + ", ";

                if ((DateTime.Now - LastGesture) <= new TimeSpan(0,0,0,1,0)) return;
                if (gesture.fingers == 4)
                {
                    var excelWorksheet = (Excel.Worksheet)Application.ActiveSheet;
                    Excel.Worksheet newsheet = null;
                    switch (direction.ToString())
                    {
                        case "Right":
                            newsheet = (Excel.Worksheet) excelWorksheet.Next;
                            break;
                        case "Left":
                            newsheet = (Excel.Worksheet) excelWorksheet.Previous;
                            break;
                    }
                    if (newsheet != null)
                    {
                        LastGesture = DateTime.Now;
                        newsheet.Activate();
                    }
                }
                if (gesture.fingers == 1)
                {
                    ColumnStep = 3;
                    RowStep = 5;
                    switch (direction.ToString())
                    {
                        case "Right": Application.ActiveWindow.SmallScroll(null, null, ColumnStep,null);
                            continue;
                        case "Left": Application.ActiveWindow.SmallScroll(null, null, null, ColumnStep);
                            continue;
                        case "Up": Application.ActiveWindow.SmallScroll(null, RowStep, null, null);
                            continue;
                        case "Down": Application.ActiveWindow.SmallScroll(RowStep, null, null, null);
                            continue;
                    }
                    LastGesture = DateTime.Now;
                }
                if (gesture.fingers == 3)
                {
                    switch (direction.ToString())
                    {
                        case "Right": Application.ActiveWindow.LargeScroll(0, 0, 1, 0);
                            continue;
                        case "Left": Application.ActiveWindow.LargeScroll(0, 0, 0, 1);
                            continue;
                        case "Up": Application.ActiveWindow.LargeScroll(0, 1, 0, 0);
                            continue;
                        case "Down": Application.ActiveWindow.LargeScroll(1, 0, 0, 0);
                            continue;
                    }
                    LastGesture = DateTime.Now;
                }

            }
            //Console.WriteLine("gestured " + gestures + " with " + gesture.fingers + " fingers.");
        }

        private int ColumnStep { get; set; }
        private int RowStep { get; set; }



        protected override Microsoft.Office.Core.IRibbonExtensibility CreateRibbonExtensibilityObject()
        {
            return new Ribbon();
        }
        #region VSTO generated code

        /// <summary>
        /// Required method for Designer support - do not modify
        /// the contents of this method with the code editor.
        /// </summary>
        private void InternalStartup()
        {
            this.Startup += new System.EventHandler(ThisAddIn_Startup);
            this.Shutdown += new System.EventHandler(ThisAddIn_Shutdown);
        }
        
        #endregion
    }
}
